package gus05.entity.gus.app.action.about.panel1;


import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Graphic;
import gus05.framework.resources.StringProvider;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;



public class AboutPanel1 implements Entity, Graphic {


    public String getName()				{return "gus.app.action.about.panel1";}
    public String getCreationDate()		{return "2008.04.21";}


    public static final String PROPKEY_ABOUTINFO = "app.aboutinfo";
    public static final String PROPKEY_ABOUTICON = "app.abouticon";
    
    
    private StringProvider lingString;
    private Map prop;
    
    
    private String appName;
    private String appVersion;
    private String appBuild;
    private Icon iconGus05;
    
    private SimpleDateFormat yyyy = new SimpleDateFormat("yyyy");
    private String thisYear() {return yyyy.format(new Date());}
    
    
    private String aboutInfo()
    {
        if(!prop.containsKey(PROPKEY_ABOUTINFO)) return null;
        String aboutInfo = (String) prop.get(PROPKEY_ABOUTINFO);
        return ling(aboutInfo);
    }
    
    private String ling(String key)
    {return lingString.getString(key);}
    
    
    


    public AboutPanel1() throws Exception
    {
    	appName = (String) Outside.resource(this,"app.title");
        appVersion = (String) Outside.resource(this,"app.version");
        appBuild = (String) Outside.resource(this,"app.creationdate");
        lingString = (StringProvider) Outside.resource(this,"lingString");
        prop = (Map) Outside.resource(this,"app.prop.map");
        
        iconGus05 = (Icon) Outside.resource(this,"icon#gus05");
    }



    public JComponent gui()
    {
    	JPanel panel = new JPanel(new GridBagLayout());
    	
        JLabel label_appName = label(18,appName);
        JLabel label_appBuild = label(15,"version "+appVersion+" build "+appBuild);
        JLabel label_author = label(12,"Augustin DELALE");
        JLabel label_email = label(12,"adelale@hotmail.com");
        JLabel label_icon = new JLabel(iconGus05);
        JLabel label_framework = label(9,"framework gus05, Copyright (c) 2007 "+thisYear()+" Augustin Delale");
        JLabel label_website = label(9,"http://www.gus05.com");
        
        String info = aboutInfo();
        JLabel infoLabel = null;
        if(info!=null) infoLabel = label(9,info);
        
        int n=0;
        panel.add(label_appName, createConstraints(1,n++));
        panel.add(label_appBuild, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        panel.add(label_author, createConstraints(1,n++));
        panel.add(label_email, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        panel.add(label_icon, createConstraints(1,n++));
        panel.add(label_framework, createConstraints(1,n++));
        panel.add(label_website, createConstraints(1,n++));
        if(info!=null) panel.add(infoLabel, createConstraints(1,n++));
        panel.add(new JLabel(" "), createConstraints(1,n++));
        
    	return panel;
    }
    
    
    
    private JLabel label(int fontSize, String text)
    {
    	JLabel label = new JLabel(text);
    	label.setFont(new Font("dialog", Font.BOLD, fontSize));
    	return label;
    }


    
    
    
    
    private GridBagConstraints createConstraints(int x, int y)
    {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = x;
        c.gridy = y;
        c.gridwidth = 1;
        c.gridheight = 1;
        c.anchor = GridBagConstraints.CENTER;
        c.weightx = 0.0;
        c.weighty = 0.0;
        return c;
    }
    
}

