package gus05.entity.gus.app.action.feedback.inputnewnote;


import java.awt.Dimension;

import javax.swing.Action;
import javax.swing.JTabbedPane;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Execute;
import gus05.framework.resources.ActionBuilder;



public class ActionInputNewNote implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.feedback.inputnewnote";}
    public String getCreationDate()		{return "2009.05.29";}

    
    public static final String ACTIONID = "UTIL_addNote";
    public static final Dimension DIM = new Dimension(500,500);

    private Service guiAddNote;
    private Service guiViewNotes;
    private Service dialogOkCancel;
    
    private ActionBuilder actionBuilder;
    private Action action;
    
    private JTabbedPane tab;
    
    

    public ActionInputNewNote() throws Exception
    {
    	guiAddNote = Outside.service(this,"gus.app.feedback.gui.addnote");
    	guiViewNotes = Outside.service(this,"gus.app.feedback.gui.viewnotes");
    	dialogOkCancel = Outside.service(this,"gus.graphic.dialog.popup0.blocked.okcancel");
    	
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
    	action = actionBuilder.build(ACTIONID,this);
    	
    	tab = new JTabbedPane();
    	tab.addTab("Add new note", guiAddNote.gui());
    	tab.addTab("View previous notes", guiViewNotes.gui());
    }
    
    

    public Object provide() throws Exception
    {return action;}

    
    
    public void execute() throws Exception
    {
    	dialogOkCancel.register("dimension",DIM);
    	boolean r = dialogOkCancel.filter(tab);
    	if(r) guiAddNote.execute();
    }
}

