package gus05.entity.gus.app.action.watchrelease.setreleaseinfo;


import javax.swing.Action;
import javax.swing.JTextArea;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Execute;
import gus05.framework.resources.ActionBuilder;



public class ActionSetReleaseInfo implements Entity, Provide, Execute {


    public String getName()				{return "gus.app.action.watchrelease.setreleaseinfo";}
    public String getCreationDate()		{return "2009.04.25";}


    public static final String ACTIONID = "WEB_releaseInfo";
    
    private Service releaseInfo;
    private Service dialogOkCancel;
    private ActionBuilder actionBuilder;
    
    private Action action;
    private JTextArea area;

    
    public ActionSetReleaseInfo() throws Exception
    {
    	releaseInfo = Outside.service(this,"gus.app.watchrelease.infos");
    	dialogOkCancel = Outside.service(this,"gus.graphic.dialog.blocked.okcancel");
    	actionBuilder = (ActionBuilder) Outside.resource(this,"app.actionbuilder");
        action = actionBuilder.build(ACTIONID,this);
        
    	area = new JTextArea(3,0);
    }



    public void execute() throws Exception
    {
    	String info = (String) releaseInfo.provide();
    	if(info!=null) area.setText(info);
    	
    	dialogOkCancel.register("title","Access informations editor");
    	boolean ok = dialogOkCancel.filter(area);
    	if(ok) releaseInfo.give(area.getText());
    }



    public Object provide() throws Exception
    {return action;}
}

