package gus05.entity.gus.app.feedback.registernotes;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;



public class RegisterNotes extends DefaultSupport implements Entity, Provide, Register, Retrieve {


    public String getName()				{return "gus.app.feedback.registernotes";}
    public String getCreationDate()		{return "2009.05.29";}

    
    private SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd_HHmmss");
    private String now() {return sdf.format(new Date());}

    
    private Service findUserName;
    private Service dirToMapProps;
    
    private File storeDir;
    private Map prop;
    

    
    public RegisterNotes() throws Exception
    {
    	findUserName = Outside.service(this,"gus.app.user.findusername");
    	dirToMapProps = Outside.service(this,"gus.data.base.dirtomapprops");
    	
    	storeDir = (File) Outside.resource(this,"defaultdir");
    	prop = (Map) Outside.resource(this,"app.prop.map");
    }



    public Object provide() throws Exception
    {return dirToMapProps.transform(storeDir);}
    
    
    
    public Object retrieve(String key) throws Exception
    {
    	File file = idToFile(key);
		return prop(file);
	}
    
    
    private String user() throws Exception
    {return (String) findUserName.provide();}

    
    
    
    
    
    private String prop(String key)
    {return prop.containsKey(key)?(String) prop.get(key):"?";}
    
    
    
    private String appGus05ID()
    {return prop("app.gus05id");}
    
    
    
    private File idToFile(String id)
    {return new File(storeDir,id+".properties");}
    
    
    
    private Properties prop(File f) throws Exception
    {
    	Properties prop = new Properties();
    	FileInputStream fis = new FileInputStream(f);
    	prop.load(fis);
    	fis.close();
    	return prop;
    }
    
    
    
    

    public void register(String key, Object obj) throws Exception
    {
    	String now = now();
    	
        Properties prop = new Properties();
        prop.setProperty(NOTES.KEY_CONTENT,(String)obj);
        prop.setProperty(NOTES.KEY_TYPE,key);
        prop.setProperty(NOTES.KEY_CREATIONTIME,now);
        prop.setProperty(NOTES.KEY_AUTHOR,user());
        prop.setProperty(NOTES.KEY_APPGUS05ID,appGus05ID());
        
        File file = idToFile(now);
        FileOutputStream fos = new FileOutputStream(file);
        prop.store(fos,"");
        fos.close();
        
        noteRegistered();
    }
    
    
    
    private void noteRegistered()
    {send(this,"noteRegistered()");}
	
}

