
package gus05.entity.gus.app.menuinit.init2;


import javax.swing.Action;
import javax.swing.JMenu;
import javax.swing.JMenuBar;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;



public class InitMenu2 implements Entity {

    public String getName()				{return "gus.app.menuinit.init2";}
    public String getCreationDate()		{return "2009.02.03";}

    
    
    private JMenuBar menuBar;
    private JMenu menu;
    
    private Service inputNoteAction;
    private Service mailToAction;
    private Service openDataAction;
    private Service openJreAction;
    private Service releaseInfo;
    private Service exitAction;
    private Service restartAction;
    private Service aboutAction;
    
    
    

    public InitMenu2() throws Exception
    {
    	inputNoteAction = Outside.service(this,"gus.app.action.feedback.inputnewnote");
    	mailToAction = Outside.service(this,"gus.app.action.mailto.appfeedback");
        openDataAction = Outside.service(this,"gus.app.action.opendatadir");
        openJreAction = Outside.service(this,"gus.app.action.openjredir");
        releaseInfo = Outside.service(this,"gus.app.action.watchrelease.setreleaseinfo");
        exitAction = Outside.service(this,"gus.app.action.exit");
        restartAction = Outside.service(this,"gus.app.action.restart");
        aboutAction = Outside.service(this,"gus.app.action.about4");
        
        menuBar = (JMenuBar) Outside.resource(this,"menubar");
        menu = new JMenu("Application");
        
        initAction(inputNoteAction);
        initAction(mailToAction);
        initAction(openDataAction);
        initAction(openJreAction);
        initAction(releaseInfo);
        menu.addSeparator();
        initAction(exitAction);
        initAction(restartAction);
        menu.addSeparator();
        initAction(aboutAction);
        
        menuBar.add(menu);
    }
    
    
    
    private void initAction(Service s) throws Exception
    {
    	if(s==null) return;
    	Action a = (Action) s.provide();
    	if(a==null) return;
    	menu.add(a);
    }
}
