package gus05.entity.gus.app.watchrelease.getreleaseprop;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Provide;
import gus05.framework.features.Support;

import java.awt.event.ActionListener;
import java.util.List;
import java.util.Properties;


public class GetReleaseProp implements Entity, Provide, Support {


    public String getName()				{return "gus.app.watchrelease.getreleaseprop";}
    public String getCreationDate()		{return "2009.02.15";}


    private Service getReleaseProp;
    private Service getInfos;
    
    private Properties prop;

    
    
    public GetReleaseProp() throws Exception
    {
    	getReleaseProp = Outside.service(this,"gus.website.restrict.getreleaseprop");
    	getInfos = Outside.service(this,"gus.app.watchrelease.infos");
    }
	
    
	
	public Object provide() throws Exception
	{
		if(prop==null) initProp();
		return prop;
	}
	
	
	
	
	private void initProp() throws Exception
	{
		String infos = (String) getInfos.provide();
    	if(infos==null || infos.equals("")) return;
    	
    	String[] n = infos.split("\n");
    	if(n.length!=3) throw new Exception("Wrong info number: "+n.length);
    	
    	String place = n[0];
    	String userName = n[1];
    	String password = n[2];
    	
    	getReleaseProp.register("userName",userName);
    	getReleaseProp.register("password",password);
    	prop = (Properties) getReleaseProp.retrieve(place);
	}
	
	
	public void addActionListener(ActionListener listener) {getInfos.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {getInfos.removeActionListener(listener);}
	public List listeners() {return getInfos.listeners();}
}

