package gus05.entity.gus.collection.map.form2.n;


import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.JTextField;


public class FormPanelModel implements ActionListener {

    
    private FormJPanel panel;
    private Map comps;
    
    
    private Map map;
	private List keys;
	private Retrieve map_ret;
	
	
	

    public FormPanelModel(FormJPanel panel, Map map)
    {
        this.panel = panel;
        comps = new HashMap();
        
        this.map = map;
		keys = new Vector(map.keySet());
		updateLabels();
		
		if(map instanceof Support)
	        ((Support)map).addActionListener(this);
	    if(map instanceof Retrieve)
	        map_ret = (Retrieve)map;
    }
    
    
    
    
    
    private JLabel createComp(String name)
    {
        String value = map.get(name).toString();
        return new JLabel(value);
    }
    
    
    
    
    private void clearComps()
    {
        Iterator it = comps.keySet().iterator();
        while(it.hasNext())
        {
            Object key = it.next();
            JTextField comp = (JTextField)comps.get(key);
            comp.removeActionListener(this);
            it.remove();
        }
    }
    
    
    
    
    
    private void updateLabels()
    {
        clearComps();
        panel.clear();
        
        for(int i=0;i<keys.size();i++)
        {
            String name = (String)keys.get(i);
            JLabel comp = createComp(name);
            
            comps.put(name,comp);
            panel.addLabel(name,comp);
        }
    }
    
    
    
    
    
    
    
    public void actionPerformed(ActionEvent evt)
    {
        mapActionPerformed(evt.getActionCommand());
    }
    
    
    
    
    private void mapActionPerformed(String command)
    {
        if(command.equals("put(Object,Object)"))	put();
        if(command.equals("remove(Object)"))		removed();
        if(command.equals("clear()"))				cleared();
        if(command.equals("putAll(Map)"))			putAll();
    }
    
    
        
        
        
    private void put()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            if(map.size()>keys.size()) addNewKey(key);
            else updateKey(key);
        }
        catch(Exception e){}
    }
    
    
    
    private void putAll()
    {
        keys = new Vector(map.keySet());
        updateLabels();
    }
    
    
    
    private void removed()
    {
        try
        {
            Object key = map_ret.retrieve("lastKey");
            removeKey(key);
        }
        catch(Exception e){}
    }
    
    
    private void cleared()
    {
        keys.clear();
        clearComps();
        panel.clear();
    }
    
    
    
    
    private void addNewKey(Object key)
    {
        keys.add(key);
        
        String name = (String)key;
        JLabel comp = createComp(name);
        
        comps.put(name,comp);
        panel.addLabel(name,comp);
    }
    
    
    private void removeKey(Object key)
    {
        int index = keys.indexOf(key);
        keys.remove(key);
        comps.remove(key);
        panel.removeLabelAt(index);
    }
    
    
    private void updateKey(Object key)
    {
        JTextField textField = (JTextField)comps.get(key);
        String value = (String)map.get(key);
        textField.setText(value);
    }

    
    
    public void mapChanged()
    {
        keys = new Vector(map.keySet());
        updateLabels();
    }
}
