package gus05.entity.gus.data.base.dirtomapprops;


import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.features.Transform;



public class DirToMapProps implements Entity, Transform {


    public String getName()				{return "gus.data.base.dirtomapprops";}
    public String getCreationDate()		{return "2009.05.29";}

    
    public static final String EXTENSION = "properties";

    private FileFilter filter;


    public DirToMapProps() throws Exception
    {
    	filter = new FileFilter(){
			public boolean accept(File f)
			{return f.isFile() && f.getName().toLowerCase().endsWith("."+EXTENSION);}
		};
    }



    public Object transform(Object obj) throws Exception
    {
    	File dir = (File) obj;
        File[] files = dir.listFiles(filter);
        
        HashMap map = new HashMap();
        for(int i=0;i<files.length;i++)
        {
        	File f = files[i];
        	String name = name(f);
        	Properties prop = prop(f);
        	map.put(name,prop);
        }
        return map;
    }
    
    
    
    
    
    
    private Properties prop(File f) throws Exception
    {
    	Properties prop = new Properties();
    	FileInputStream fis = new FileInputStream(f);
    	prop.load(fis);
    	fis.close();
    	return prop;
    }

    
    
    private String name(File f)
    {
    	String fileName = f.getName();
    	return fileName.substring(0,fileName.length()- EXTENSION.length()-1);
    }

}

