package gus05.entity.gus.data.editor.map.string.editor2;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Map;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.features.Support;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;



public class MapStringEditor2 implements Entity, Give, Provide, Graphic {


    public String getName()				{return "gus.data.editor.map.string.editor2";}
    public String getCreationDate()		{return "2006.10.10";}



    private Service textFieldJapanese;
    private Service textFieldRecall;
    private Service factory;
    private Service mapSupport;
    private Service form;
    
    private JTable mapTable;
    private JTextField keyTextField;
    private JTextField valueTextField;
    private JLabel numberLabel;
    private JPanel panel;
    
    private Map map;
    
    
    
    
    public MapStringEditor2() throws Exception
    {
        factory = Outside.service(this,"gus.collection.map.string.guifactory");
        form = Outside.service(this,"gus.graphic.panel.form1");
        mapSupport = Outside.service(this,"gus.collection.support");
        
        textFieldJapanese = Outside.service(this,"gus.graphic.textfield.japanese1");
        textFieldRecall = Outside.service(this,"gus.graphic.textfield.recall");
        
        mapTable = (JTable)factory.retrieve("mapJTable");
        numberLabel = (JLabel)factory.retrieve("mapJLabel");
        keyTextField = (JTextField)factory.retrieve("mapJTextField");
        valueTextField = new JTextField();
        
        textFieldJapanese.give(keyTextField);
        textFieldJapanese.give(valueTextField);
        
        textFieldRecall.give(keyTextField);
        textFieldRecall.give(valueTextField);
        
        numberLabel.setText(" keys=");
        
        
        keyTextField.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                valueTextField.requestFocusInWindow();
            }
        });
        
        valueTextField.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {
                addEntry();
                keyTextField.requestFocusInWindow();
            }
        });
        
        form.register(" key: ",keyTextField);
        form.register(" value: ",valueTextField);
        
        panel = new JPanel(new BorderLayout());
        panel.add(form.gui(),BorderLayout.NORTH);
        panel.add(new JScrollPane(mapTable),BorderLayout.CENTER);
        panel.add(numberLabel,BorderLayout.SOUTH);
        
        Outside.service(this,"gus.graphic.table.tooltip").give(mapTable);
        Outside.service(this,"gus.graphic.table.sort").give(mapTable);
    }
    
    
    
    
    private void addEntry()
    {
        String newKey = keyTextField.getText();
        String newValue = valueTextField.getText();
        
        map.put(newKey,newValue);
        keyTextField.setText("");
        valueTextField.setText("");
    }
    
    
    
    



    public void give(Object obj) throws Exception
    {
        map = (Map)obj;
        if(!(map instanceof Support))
        	map = (Map) mapSupport.transform(map);
        factory.give(map);
    }
    
    
    
    public Object provide() throws Exception
	{return map;}
    
    

    public JComponent gui()
    {return panel;}
}

