package gus05.entity.gus.database.table.viewer1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

import java.awt.BorderLayout;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.util.ArrayList;



public class TableViewer1 implements Entity, Give, Graphic {


    public String getName()				{return "gus.database.table.viewer1";}
    public String getCreationDate()		{return "2009.12.02";}


    private Service tableTooltip;
    
    private JPanel panel;
    
    private TableModel0 model;
    private JTable table;
    private JLabel labelInfo;

    private ResultSet resultSet;
    private ResultSetMetaData rsmd;
    
    private String[] columns;
    private ArrayList data;
    private int columnCount;
    private int rowCount;
    
    
    

    public TableViewer1() throws Exception
    {
    	tableTooltip = Outside.service(this,"gus.graphic.table.tooltip");
    	
    	model = new TableModel0();
    	table = new JTable(model);
    	tableTooltip.give(table);
    	
    	labelInfo = new JLabel(" ");
    	
        panel = new JPanel(new BorderLayout());
        panel.add(new JScrollPane(table),BorderLayout.CENTER);
        panel.add(labelInfo,BorderLayout.SOUTH);
    }



    public void give(Object obj) throws Exception
    {
    	resultSet = (ResultSet) obj;
    	
    	if(resultSet==null)
    	{
    		rsmd = null;
    		data = null;
    		columnCount = 0;
    		rowCount = 0;
    		labelInfo.setText(" ");
    		model.fireTableStructureChanged();
    		return;
    	}
    	
    	rsmd = resultSet.getMetaData();
    	columnCount = rsmd.getColumnCount();
    	
    	columns = new String[columnCount];
    	for(int i=0;i<columnCount;i++)
    	columns[i] = rsmd.getColumnName(i+1);
    	
    	data = new ArrayList();
    	while(resultSet.next())
    	{
    		String[] row = new String[columnCount];
    		for(int i=0;i<columnCount;i++)
    		row[i] = resultSet.getString(i+1);
    		data.add(row);
    	}
    	rowCount = data.size();
    	resultSet.close();
    	
    	labelInfo.setText(" size=["+rowCount+","+columnCount+"]");
    	model.fireTableStructureChanged();
    }



    public JComponent gui()
    {return panel;}

    
    
    
    
    
    

    
    
    

    
    
    private class TableModel0 extends AbstractTableModel
    {
		public int getColumnCount() {return columnCount;}
		public int getRowCount() {return rowCount;}
		
		public String getColumnName(int y) {return columns[y];}
		public Class getColumnClass(int y) {return String.class;}

		public Object getValueAt(int x, int y)
		{
			String[] row = (String[]) data.get(x);
			return row[y];
		}
    }
}

