package gus05.entity.gus.file.access.string.tab;


import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;

import gus05.framework.core.Entity;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Transform;



public class FileAccessStringTab implements Entity, Transform {


    public String getName()				{return "gus.file.access.string.tab";}
    public String getCreationDate()		{return "2008.02.27";}

    
    
    public Object transform(Object obj) throws Exception
    {return new FileHolder((File)obj);}

    
    
    private class FileHolder implements Give, Provide
    {
        private File file;
        FileHolder(File file)
        {this.file = file;}
        
        public void give(Object obj) throws Exception
        {writeTab(file,(String[][])obj);}
        
        public Object provide() throws Exception
        {return readTab(file);}
    }

    
    
    
    
    private void writeTab(File file, String[][] tab) throws Exception
    {
    	PrintStream out = new PrintStream(file);
    	if(tab.length==0) return;
    	if(tab[0].length==0) return;
    	
    	for(int i=0;i<tab.length;i++)
    	{
    		String[] line = tab[i];
    		for(int j=0;j<line.length-1;j++)
        	out.print(line[j]+"\t");
    		
    		out.println(line[line.length-1]);
    	}
    	out.close();
    }
    
    
    
    
    private String[][] readTab(File file) throws Exception
    {
        String text = readTextFile(file);
        String[] a = text.split("[\n\r]+",-1);
        int nb_lines = a.length;
        
        int nb_elems = 0;
        for(int i=0;i<nb_lines;i++)
        {
            int w = a[i].split("\t",-1).length;
            if(nb_elems<w)nb_elems = w;
        }
        
        if(nb_lines==0)throw new Exception("no line delimiters found");
        if(nb_elems==0)throw new Exception("no elements delimiters found");
        
        String[][] result = new String[nb_lines][nb_elems];
        for(int i=0;i<nb_lines;i++)
        for(int j=0;j<nb_elems;j++)
        result[i][j]="";
            
        for(int i=0;i<nb_lines;i++)
        {
            String[] n = a[i].split("\t",-1);
            for(int j=0;j<n.length;j++)
            result[i][j]=n[j];
        }
        return result;
    }


    
    
    private String readTextFile(File f) throws Exception
    {
        FileReader fr = new FileReader(f);   
        char[] a= new char[(int)f.length()];
        fr.read(a,0,(int)f.length());
        fr.close();
        return new String(a);
    }
}

