
package gus05.entity.gus.file.action.choose.file;

import java.awt.Container;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.resources.FileProvider;


public class FileChooser implements Entity, FileProvider {

    
    public String getName()				{return "gus.file.action.choose.file";}
    public String getCreationDate()		{return "2006.06.07";}

    
    
    private Service fcHolder;
    private JFileChooser fc;
    
    
    
    public FileChooser() throws Exception
    {
    	fcHolder = Outside.service(this,"gus.graphic.filechooser.holder");
    }
    
    
    private void init()
    {
    	try
    	{
    		if(fc==null) fc = (JFileChooser) fcHolder.provide();
    		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
    	}
    	catch(Exception e)
    	{Outside.err(this,"init()",e);}
    }
    
    
    
    
    public File getFile(String key)
    {
    	init();
        int val = showDialog(key);
        if(val==JFileChooser.APPROVE_OPTION)
            return fc.getSelectedFile();
        return null;
    }

    
    private int showDialog(String key)
    {
        if(key.equals("save")) return fc.showSaveDialog(null);
        if(key.equals("open")) return fc.showOpenDialog(null);
        return showCustomDialog(key);
    }
    
    
    
    
    private int showCustomDialog(String key)
    {
    	String[] n = (String[]) key.split("\t");
    	
    	String title = n[0];
    	fc.setDialogTitle(title);
    	if(n.length==1) return fc.showDialog(null,"OK");
    	
    	String button1 = n[1];
    	if(n.length==2) return fc.showDialog(null,button1);
    	
    	String button2 = n[2];
        JButton cancelButton = cancelButton();
        cancelButton.setText(button2);
        return fc.showDialog(null,button1);
    }
    
    
    
    
    

    private JButton cancelButton()
    {
    	Container c1 = (Container) fc.getComponent(fc.getComponentCount()-1);
    	Container c2 = (Container) c1.getComponent(c1.getComponentCount()-1);
    	return (JButton) c2.getComponent(c2.getComponentCount()-1);
    }
    
    
	
}
