
package gus05.entity.gus.file.action.choose.file.filtered;

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.resources.FileProvider;


public class FileChooserFiltered implements Entity, FileProvider {

    
    public String getName()				{return "gus.file.action.choose.file.filtered";}
    public String getCreationDate()		{return "2008.02.27";}

    
    private Service fcHolder;
    private JFileChooser fc;
    
    
    
    public FileChooserFiltered() throws Exception
    {
    	fcHolder = Outside.service(this,"gus.graphic.filechooser.holder");
    }
    
    
    private void init()
    {
    	try
    	{
    		if(fc==null) fc = (JFileChooser) fcHolder.provide();
    		fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
    	}
    	catch(Exception e)
    	{Outside.err(this,"init()",e);}
    }
    
    
    

    
    
    
    
    public File getFile(String key)
    {
    	init();
    	String[] n = key.split("\t");
    	String action = n[0];
    	String fileDescription = n[1];
    	String fileExtension = n[2];
    	
    	FileNameExtensionFilter filter = new FileNameExtensionFilter(fileDescription, fileExtension);
        
    	fc.setFileFilter(filter);
        int val = showDialog(action);
        fc.setFileFilter(null);
        
        if(val==JFileChooser.APPROVE_OPTION)
            return fc.getSelectedFile();
        return null;
    }

    
    private int showDialog(String key)
    {
        if(key.equals("save")) return fc.showSaveDialog(null);
        if(key.equals("open")) return fc.showOpenDialog(null);
        
        fc.setDialogTitle(key);
        return fc.showDialog(null,"OK");
    }
}
