
package gus05.entity.gus.file.action.choose.filedir;

import java.io.File;

import javax.swing.JFileChooser;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.resources.FileProvider;


public class FileDirChooser implements Entity, FileProvider {

    
    public String getName()				{return "gus.file.action.choose.filedir";}
    public String getCreationDate()		{return "2006.06.07";}

    
    
    private Service fcHolder;
    private JFileChooser fc;
    
    
    
    public FileDirChooser() throws Exception
    {
    	fcHolder = Outside.service(this,"gus.graphic.filechooser.holder");
    }
    
    
    
    private void init()
    {
    	try
    	{
    		if(fc==null) fc = (JFileChooser) fcHolder.provide();
    		fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
    	}
    	catch(Exception e)
    	{Outside.err(this,"init()",e);}
    }
    
    
    
    
    
    public File getFile(String key)
    {
    	init();
        int val = showDialog(key);
        if(val==JFileChooser.APPROVE_OPTION)
            return fc.getSelectedFile();
        return null;
    }

    
    
    private int showDialog(String key)
    {
        if(key.equals("save")) return fc.showSaveDialog(null);
        if(key.equals("open")) return fc.showOpenDialog(null);
        
        fc.setDialogTitle(key);
        return fc.showDialog(null,"OK");
    }
}
