
package gus05.entity.gus.file.convert.csv.parser;

import gus05.framework.core.Entity;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;


public class CsvParser implements Entity, Transform, Retrieve
{

    public String getName()				{return "gus.file.convert.csv.parser";}
    public String getCreationDate()		{return "2006.07.15";}
    

    public static String delim_line = "@@<@@LINE@@>@@";
    public static String delim_elem = "@@<@@ELEM@@>@@";

    public static char CHAR_DELIM = ';';
    public static String STRING_DELIM = ";";
    
    
    
    public Object transform(Object obj) throws Exception
    {
        String in2 = formatInput(obj.toString());
        
        String[] a = in2.split(delim_line);
        int nb_lines = a.length;
        
        int nb_elems = 0;
        for(int i=0;i<nb_lines;i++)
        {
            int w = a[i].split(delim_elem).length;
            nb_elems = Math.max(nb_elems,w);
        }
        
        if(nb_lines==0)throw new Exception("no line delimiters found");
        if(nb_elems==0)throw new Exception("no elements delimiters found");
        
        String[][] result = new String[nb_lines][nb_elems];
        for(int i=0;i<nb_lines;i++)
        for(int j=0;j<nb_elems;j++)
        result[i][j]="";
            
        for(int i=0;i<nb_lines;i++)
        {
            String[] n = a[i].split(delim_elem,-1);
            for(int j=0;j<n.length;j++)
            result[i][j]=n[j];
        }
        return result;
    }
    
    
    
    
    // parsing code
    
    private int situation;
    
    private String formatInput(String in)
    {
        StringBuffer out = new StringBuffer();
        situation = 0;
        
        for(int i=0;i<in.length();i++)
        perform_FormatInput(out,in,in.charAt(i),i);
        return out.toString();
    }
    
    private void perform_FormatInput(StringBuffer out, String in, char c,int index)
    {
        switch(situation)
        {
            case 0:  
            if(c=='"'){situation=1;break;}
            if(c==CHAR_DELIM){out.append(delim_elem);break;}
            if(c=='\n'){out.append(delim_line);break;}
            if(c=='\r'){break;}
            out.append(c);
            break;

            case 1:
            if(c=='"'){situation=2;break;}
            out.append(c);
            break;

            case 2:
            if(c=='"'){situation=1;out.append('"');break;}

            situation=0;
            if(c==CHAR_DELIM){out.append(delim_elem);break;}
            if(c=='\n'){out.append(delim_line);break;}
            if(c=='\r'){break;}
            out.append(c);
            break;
        }
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public Object retrieve(String key) throws Exception
    {    
        if(key.equals("help")) return help();
        throw new Exception("Unknown key: "+key);
    }
    
    
    private String help()
    {
        StringBuffer b = new StringBuffer("Aide pour CVS PARSER\n\n");
        b.append("Parseur de format CVS qui gnre un String[][]  partir d'un String\n");
        return b.toString();
    }
}
