package gus05.entity.gus.file.editor.sqlitedb.editor1;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.BorderLayout;
import java.awt.Font;
import java.io.File;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.util.Vector;



public class SQLiteDbEditor1 extends DefaultSupport implements Entity, Give, Graphic, Register, ListSelectionListener {


    public String getName()				{return "gus.file.editor.sqlitedb.editor1";}
    public String getCreationDate()		{return "2009.12.02";}


    private Service listRendering;
    private Service tableViewer;
    
    private JPanel panel;
    private JList list;
    private JLabel labelInfo;
    private JLabel labelNumber;
    
    private File file;
    private String db_url;
    private Connection cx;
    private DatabaseMetaData dbmd;
    
    private String selectedTableName;
    private ResultSet selectedTableResultSet;
    
    


    public SQLiteDbEditor1() throws Exception
    {
    	listRendering = Outside.service(this,"gus.graphic.list.rendering0");
    	tableViewer = Outside.service(this,"gus.database.table.viewer1");
    	
    	list = new JList();
    	listRendering.register("FILE_tab",list);
    	list.addListSelectionListener(this);
    	
    	labelInfo = new JLabel(" ");
    	labelInfo.setFont(labelInfo.getFont().deriveFont(Font.ITALIC));
    	
    	labelNumber = new JLabel(" ");
    	
    	JPanel p_left = new JPanel(new BorderLayout());
    	p_left.add(new JScrollPane(list),BorderLayout.CENTER);
    	p_left.add(labelNumber,BorderLayout.SOUTH);
    	
    	
    	JSplitPane split = new JSplitPane();
    	split.setLeftComponent(p_left);
    	split.setRightComponent(tableViewer.gui());
    	
        panel = new JPanel(new BorderLayout());
        panel.add(split,BorderLayout.CENTER);
        panel.add(labelInfo,BorderLayout.SOUTH);
    }



    public void give(Object obj) throws Exception
    {
    	file = (File) obj;
    	db_url = "jdbc:sqlite:/"+file.getAbsolutePath();
    	cx = DriverManager.getConnection(db_url);
    	dbmd = cx.getMetaData();
    	
    	ResultSet rs = dbmd.getTables(null, null, null,new String[]{"TABLE"});
    	Vector vec = new Vector();
		while (rs.next()) vec.add(rs.getString("TABLE_NAME"));
		
		labelInfo.setText(" "+db_url);
		list.setListData(vec);
		labelNumber.setText(" "+vec.size()+" tables found");
		resetTableViewer();
    }
    
    
    
    public void valueChanged(ListSelectionEvent e)
	{tableSelected();}
    
    
    
    private void tableSelected()
    {
    	try
    	{
    		if(list.isSelectionEmpty())
    		{
    			resetTableViewer();
    			return;
    		}
    		selectedTableName = (String) list.getSelectedValue();
    		selectedTableResultSet = cx.createStatement().executeQuery("SELECT * FROM "+selectedTableName);
    		tableViewer.give(selectedTableResultSet);
    	}
    	catch(Exception e)
    	{Outside.err(this,"tableSelected()",e);}
    }
    
    
    
    
    
    private void resetTableViewer()
    {
    	try
    	{
    		selectedTableName = null;
        	selectedTableResultSet = null;
        	tableViewer.give(null);
    	}
    	catch(Exception e)
    	{Outside.err(this,"resetTableViewer()",e);}
    }
    
    



    public JComponent gui()
    {return panel;}



    public void register(String key, Object obj) throws Exception
    {
        throw new Exception("Unknown key: "+key);
    }
	


}

