package gus05.entity.gus.file.editor.string.editor1;

import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;

import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;


public class StringEditor1 extends DefaultSupport implements Entity, Graphic, Give, Register, Retrieve {

    public String getName()				{return "gus.file.editor.string.editor1";}
    public String getCreationDate()		{return "2006.07.14";}
    
    
    private JTextArea textArea;
    private JScrollPane scroll;
    private File file;
    
    
    public StringEditor1() throws Exception
    {
        textArea = new JTextArea();
        textArea.getDocument().addDocumentListener(new DocumentListener()
        {
            public void insertUpdate(DocumentEvent e) {dataModified();}
            public void removeUpdate(DocumentEvent e) {dataModified();}
            public void changedUpdate(DocumentEvent e) {}
        });
        
        Outside.service(this,"gus.graphic.textcomp.action.set1").give(textArea);
        scroll = new JScrollPane(textArea);
    }
    
    
    private void dataModified()
    {send(this,"dataModified()");}
    
    
    public JComponent gui()
    {return scroll;}
    
    
    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        String text = readFile();
        
        setActivated(false);
        textArea.setText(text);
        textArea.moveCaretPosition(0);
        setActivated(true);
    }
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("save"))
        {saveFile();return;}
        
        if(key.equals("data"))
        {textArea.setText((String)obj);return;}
        
        throw new Exception("Unknown key: "+key);
    }

    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("data")) return textArea.getText();
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    private String readFile() throws Exception
    {
        if(file==null)return "";
        FileReader fr = new FileReader(file);	
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a); 
    }
    
    
    private void saveFile()
    {
        try
        {
            if(file==null) return;
            String text = textArea.getText();
            PrintStream p = new PrintStream(file);
            p.print(text);
            p.close();
        }
        catch(Exception e)
        {Outside.err(this,"saveFile()",e);}
    }
    
}
