/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.editor.string.lnk.editor1;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileReader;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;



/**
* @author gus
*/
public class LnkEditor1 extends DefaultSupport implements Entity, Graphic, Give, Register
{

    public String getName()				{return "gus.file.editor.string.lnk.editor1";}
    public String getCreationDate()		{return "2006.07.14";}
    
    

    private JPanel panel;
    private JTextArea textArea;
    private JButton button;
    
    private Service label;
    private File file;
    
    
    

    public LnkEditor1() throws Exception
    {
        label = Outside.service(this,"gus.file.label.filelabel");
        
        textArea = new JTextArea();
        textArea.setEditable(false);
        textArea.setLineWrap(true);
        
        button = new JButton("Extract path");
        button.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {extractPath();}});
        
        panel = new JPanel(new BorderLayout());
        panel.add(label.gui(),BorderLayout.NORTH);
        panel.add(new JScrollPane(textArea),BorderLayout.CENTER);
        panel.add(button,BorderLayout.SOUTH);
    }






    public JComponent gui()
    {return panel;}



    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        String content = readFile();
        textArea.setText(content);
        label.give("");
    }
    
    
    
    
    private void extractPath()
    {
        try
        {
            String path = textArea.getSelectedText();
            File f = new File(path);
            label.give(f);
        }
        catch(Exception e)
        {Outside.err(this,"extractPath()",e);}
    }
    
    
    private String readFile() throws Exception
    {
        FileReader fr = new FileReader(file);	
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a); 
    }

    
    
    
    public void register(String key, Object obj) throws Exception {
    }

}
