package gus05.entity.gus.file.editor.string.table.csv.editor1;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.features.Support;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JPanel;



public class CsvEditor1 implements Entity, Graphic, Give, Register, Support
{

    public String getName()				{return "gus.file.editor.string.table.csv.editor1";}
    public String getCreationDate()		{return "2006.07.14";}


    private Service csvParser;
    private Service csvGenerator;
    private Service string2Editor;
    
    private File file;
    private JPanel panel;
    
    
    
    public CsvEditor1() throws Exception
    {
        csvParser = Outside.service(this,"gus.file.convert.csv.parser");
        csvGenerator = Outside.service(this,"gus.file.convert.csv.generator");
        string2Editor = Outside.service(this,"gus.data.editor.string2.editor1");
        
        panel = new JPanel(new BorderLayout());
        panel.add(string2Editor.gui(),BorderLayout.CENTER);
        //panel.add(label_info,BorderLayout.SOUTH);
    }

    
    

    public JComponent gui()
    {return panel;}


    

    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        String content = readFile();
        String[][] tab = (String[][])csvParser.transform(content);
        string2Editor.give(tab);
        
        String editable = file.canWrite()?"true":"false";
        string2Editor.register("editable", editable);
    }


    

    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("save"))
        {
            saveFile();
            return;
        }
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    
    
    private void saveFile()
    {
        try
        {
            String[][] tab = (String[][]) string2Editor.provide();
            String text = (String) csvGenerator.transform(tab);
            PrintStream p = new PrintStream(file);
            p.print(text);
            p.close();
        }
        catch(Exception e)
        {Outside.err(this,"saveFile()",e);}
    }
    
    
    
    
    private String readFile() throws Exception
    {
        FileReader fr = new FileReader(file);	
        char[] a= new char[(int)file.length()];
        fr.read(a,0,(int)file.length());
        fr.close();
        return new String(a); 
    }
    
    
	public void addActionListener(ActionListener listener) {string2Editor.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {string2Editor.removeActionListener(listener);}
	public List listeners() {return string2Editor.listeners();}
	
}
