package gus05.entity.gus.file.editor.zip.editor2;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Register;
import gus05.framework.tools.DefaultSupport;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;



public class ZipEditor2 extends DefaultSupport implements Entity, Give, Graphic, Register, Execute, ActionListener {


    public String getName()				{return "gus.file.editor.zip.editor2";}
    public String getCreationDate()		{return "2006.08.07";}


    private Service quickUnzip;
    
    private JTable table;
    private JButton button;
    private JPanel panel;
    
    private File file;
    private ZipFile zipFile;



    public ZipEditor2() throws Exception
    {
        quickUnzip = Outside.service(this,"gus.file.zip.quickunzip");
        
        table = new JTable();
        table.setEnabled(false);
        
        button = new JButton("unzip");
        button.addActionListener(this);
        
        panel = new JPanel(new BorderLayout());
        panel.add(new JScrollPane(table),BorderLayout.CENTER);
        panel.add(button,BorderLayout.SOUTH);
    }


    public JComponent gui()
    {return panel;}

    
    

    public void give(Object obj) throws Exception
    {
        file = (File)obj;
        zipFile = new ZipFile(file,ZipFile.OPEN_READ);
        
        String[][] content = buildContent();
        String[] columns = new String[]{"name","comment","compressed size","size","CRC","directory"};
        
        table.setModel(new DefaultTableModel(content,columns));
        zipFile.close();
    }



    
    
    
    
    private String[][] buildContent()
    {
        String[][] content = new String[zipFile.size()][6];
        Enumeration en = zipFile.entries();
        
        int n=0;
        while(en.hasMoreElements())
        {
            ZipEntry entry = (ZipEntry)en.nextElement();
            content[n][0] = entry.getName();
            content[n][1] = entry.getComment();
            content[n][2] = ""+entry.getCompressedSize();
            content[n][3] = ""+entry.getSize();
            content[n][4] = ""+entry.getCrc();
            content[n][5] = entry.isDirectory()?"DIR":"";
            n++;
        }
        return content;
    }
    
    


    public void register(String key, Object obj) throws Exception
    {
        throw new Exception("Unknown key: "+key);
    }
    
    
    
    public void execute() throws Exception
    {unzipFile();}
    
    
    public void actionPerformed(ActionEvent e)
    {unzipFile();}


    
    
    private void unzipFile()
    {
        try
        {
            if(file!=null)
            quickUnzip.give(file);
        }
        catch(Exception e)
        {Outside.err(this,"unzipFile()",e);}
    }
}

