/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.file.explorer.tree2;

/**
 *
 * @author  gus
 */
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;

import javax.swing.tree.*;


abstract class AbstractJTree extends JTree {
    
    
    
    protected TreeSelectionModel selection;
    
    
    
    
    public AbstractJTree()
    {
        super();
        
        selection = getSelectionModel();
        
        addTreeSelectionListener(new TreeSelectionListener(){
        public void valueChanged(TreeSelectionEvent evt)
        {
            if(isSelectionEmpty())return;
            selectFromJTree();
        }});
        
        
        
        addMouseListener(new MouseAdapter() {
            public void mousePressed(MouseEvent evt)
            {
                if(isSelectionEmpty())
                    return;
                
                TreePath path = getClosestPathForLocation(evt.getX(),evt.getY());
                if(path.equals(getSelectionPath()))
                    selectFromJTree(); 
            }
        });
        
        addKeyListener(new KeyAdapter(){
            public void keyPressed(KeyEvent e)
            {
                if(isSelectionEmpty())
                    return;
                    
                if(e.getKeyCode()==KeyEvent.VK_ENTER)    
                    selectFromJTree();  
            }
        });
    }
    
    
    
    
    
    protected abstract void selectFromJTree();
}
