package gus05.entity.gus.file.label.chooseroot2;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.FileProvider;
import gus05.framework.resources.IconProvider;



public class LabelChooseRoot2 implements Entity, Transform {


    public String getName()				{return "gus.file.label.chooseroot2";}
    public String getCreationDate()		{return "2009.12.04";}

    
    private Service fileIcon;
    private IconProvider iconProvider;
    private FileProvider fileProvider;
    
    public LabelChooseRoot2() throws Exception
    {
    	fileIcon = Outside.service(this,"gus.icondisplay.file1");
        iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");
        fileProvider = (FileProvider) Outside.resource(this,"app.files");
    }

  
    
    public Object transform(Object obj) throws Exception
    {
        Give give = (Give)obj;
        return new JLabelRoot(give);
    }
    
    
    
    private void giveFile(Give give, File root)
    {
        try{give.give(root);}
        catch(Exception e)
        {Outside.err(this,"giveFile(Give,File)",e);}
    }
    
    
    
    private Icon icon(File file)
    {
    	try{return (Icon) fileIcon.transform(file);}
    	catch(Exception e)
    	{Outside.err(this,"icon(File)",e);}
    	return null;
    }
    
    private Icon icon(String key)
    {return iconProvider.getIcon(key);}
    
    private File file(String key)
    {return fileProvider.getFile(key);}
    
    
    
    
    
    private JPopupMenu menu_roots(Give give)
    {
    	JPopupMenu popup = new JPopupMenu("Roots");
    	popup.setBorderPainted(false);
    	
    	File[] roots = File.listRoots();
        for(int i=0;i<roots.length;i++)
        popup.add(new JMenuItemRoot(give,roots[i]));
    	return popup;
    }
    
    
    
    private void addItem(JPopupMenu popup, Give give, File file)
    {
    	if(file==null || !file.exists()) return;
    	popup.add(new JMenuItemRoot(give,file));
    }
    
    
    
    
    
    
    
    private class JLabelRoot extends JLabel implements MouseListener
    {
        private JPopupMenu popup;
        
        public JLabelRoot(Give give)
        {
            super(icon("FILEACTION_chooseRoot"));
            setFocusable(true);
            addMouseListener(this);
            
            popup = new JPopupMenu();
            popup.setBorderPainted(false);
            
            File[] roots = File.listRoots();
            
            for(int i=0;i<roots.length;i++)
            addItem(popup,give,roots[i]);
            popup.addSeparator();
            addItem(popup,give,file("path.sys.user.home"));
            addItem(popup,give,file("path.env.ProgramFiles"));
            addItem(popup,give,file("path.sys.java.home"));
        }
        
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mousePressed(MouseEvent e) {showPopup();}
        public void mouseReleased(MouseEvent e) {}
        
        private void showPopup()
        {popup.show(this,0,getHeight());}
    }
    
    
    
    
    
    
    
    
    private class JMenuItemRoot extends JMenuItem implements ActionListener
    {
        private Give give;
        private File root;
        
        public JMenuItemRoot(Give give, File dir)
        {
            super(dir.getAbsolutePath(),icon(dir));
            this.give = give;
            this.root = dir;
            addActionListener(this);
        }

        public void actionPerformed(ActionEvent e)
        {giveFile(give,root);}
    }
    
}

