package gus05.entity.gus.file.savedata.tabtoexcel;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Transform;
import gus05.framework.resources.FileProvider;



public class SaveDataTabToExcel implements Entity, Give, Transform {


    public String getName()				{return "gus.file.savedata.tabtoexcel";}
    public String getCreationDate()		{return "2008.02.27";}

    
    public static final String OPENFILE = "save\tExcel files\txls";

    private FileProvider fileChooser;
    private Service fileAccess;

    
    public SaveDataTabToExcel() throws Exception
    {
    	fileChooser = (FileProvider) Outside.resource(this,"gus.file.action.choose.file.filtered");
    	fileAccess = Outside.service(this,"gus.file.access.string.csvtab");
    }



    public void give(Object obj) throws Exception
    {
    	String[][] data = (String[][]) obj;
    	saveData(data);
    }



    public Object transform(Object obj) throws Exception
    {
    	String[][] data = (String[][]) obj;
        return saveData(data);
    }
    
    
    
    private File saveData(String[][] data) throws Exception
    {
    	File f = fileChooser.getFile(OPENFILE);
    	if(f==null) return null;
    	
    	if(!f.getName().endsWith(".xls"))
    		f = new File(f.getAbsolutePath()+".xls");
    	
    	Give saver = (Give) fileAccess.transform(f);
    	saver.give(data);
    	return f;
    }
}

