package gus05.entity.gus.file.zip.quickunzip;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;



public class QuickUnzip implements Entity, Give {


    public String getName()				{return "gus.file.zip.quickunzip";}
    public String getCreationDate()		{return "2007.08.07";}



    private Service zipMaker;

    public QuickUnzip() throws Exception
    {zipMaker = Outside.service(this,"gus.file.zip.zipmaker1");}



    public void give(Object obj) throws Exception
    {
        File inputFile = (File) obj;
        if(!inputFile.isFile())
            throw new Exception("Invalid input: "+inputFile);
        
        String name = inputFile.getName();
        String[] n = name.split("\\.");
        if(n.length>0)
        name = name.substring(0,name.length()-n[n.length-1].length()-1);
        
        File outputDir = new File(inputFile.getParentFile(),name);
        outputDir.mkdir();
        
        zipMaker.register("input",inputFile);
        zipMaker.register("output",outputDir);
        zipMaker.give("unzip");
    }


}

