package gus05.entity.gus.graphic.dialog.blocked.okcancel;


import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JPanel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Filter;
import gus05.framework.features.Register;



public class DialogOkCancel implements Entity, Filter, Register {


    public String getName()				{return "gus.graphic.dialog.blocked.okcancel";}
    public String getCreationDate()		{return "2009.03.17";}

    
    private JFrame mainFrame;
    private Dialog0 dialog;
    
    private JPanel p_buttons;
    private JButton button_add;
    private JButton button_cancel;
    
    private boolean ok = false;
    
    

    public DialogOkCancel() throws Exception
    {
    	mainFrame = (JFrame) Outside.resource(this,"app.gui.frame");
    	dialog = new Dialog0(mainFrame);
    	
    	button_add = new JButton("OK");
    	button_add.setBorder(new OvalBorder());
    	button_add.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{add();}
		});
    	button_cancel = new JButton("Cancel");
    	button_cancel.setBorder(new OvalBorder());
    	button_cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{cancel();}
		});
    	
    	p_buttons = new JPanel(new GridLayout(1,2,8,8));
    	p_buttons.add(button_add);
		p_buttons.add(button_cancel);
    }

    

	public boolean filter(Object obj) throws Exception
	{
		JComponent content = (JComponent) obj;
		
		JPanel panel = new JPanel(new BorderLayout());
		panel.add(content,BorderLayout.CENTER);
		panel.add(p_buttons,BorderLayout.SOUTH);
		
		dialog.showContent(panel);
		return ok;
	}
	
	
	public void register(String key, Object obj) throws Exception
	{
		if(key.equals("title")) {dialog.setTitle((String) obj);return;}
		throw new Exception("Unknown key: "+key);
	}
	
	
	
	
	
	private void cancel()
	{
		try
		{
			ok = false;
			dialog.hideContent();
		}
		catch(Exception e)
		{Outside.err(this,"cancel()",e);}
	}
	
	
	
	private void add()
	{
		try
		{
			ok = true;
			dialog.hideContent();
		}
		catch(Exception e)
		{Outside.err(this,"add()",e);}
	}
	
}

