package gus05.entity.gus.graphic.dialog.popup0.blocked.okcancel;


import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JPanel;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Filter;
import gus05.framework.features.Register;



public class DialogOkCancel implements Entity, Filter, Register {


    public String getName()				{return "gus.graphic.dialog.popup0.blocked.okcancel";}
    public String getCreationDate()		{return "2009.03.17";}

    
    private Service dialog;
    
    private JPanel panel;
    private JButton button_add;
    private JButton button_cancel;
    
    private boolean ok = false;
    
    

    public DialogOkCancel() throws Exception
    {
    	dialog = Outside.service(this,"gus.graphic.dialog.popup0.blocked");
    	
    	button_add = new JButton("OK");
    	button_add.setBorder(new OvalBorder());
    	button_add.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{add();}
		});
    	button_cancel = new JButton("Cancel");
    	button_cancel.setBorder(new OvalBorder());
    	button_cancel.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{cancel();}
		});
    	
    	JPanel p_buttons = new JPanel(new GridLayout(1,2,8,8));
    	p_buttons.add(button_add);
		p_buttons.add(button_cancel);
		
		panel = new JPanel(new BorderLayout());
		panel.add(p_buttons,BorderLayout.SOUTH);
    }
    
    
    
    
    public void register(String key, Object obj) throws Exception
    {dialog.register(key,obj);}

    

	public boolean filter(Object obj) throws Exception
	{
		JComponent content = (JComponent) obj;
		panel.add(content,BorderLayout.CENTER);
		dialog.give(panel);
		return ok;
	}
	
	
	
	
	
	
	private void cancel()
	{
		try
		{
			ok = false;
			dialog.give(null);
		}
		catch(Exception e)
		{Outside.err(this,"cancel()",e);}
	}
	
	
	
	private void add()
	{
		try
		{
			ok = true;
			dialog.give(null);
		}
		catch(Exception e)
		{Outside.err(this,"add()",e);}
	}
}

