package gus05.entity.gus.graphic.dialog.popup1_size600;

import gus05.framework.tools.DefaultSupport;

import java.awt.AWTEvent;
import java.awt.Toolkit;
import java.awt.event.AWTEventListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowStateListener;

import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;


class Dialog1 extends JDialog implements AWTEventListener, WindowStateListener
{
	private JFrame parent;
	private DefaultSupport support;
	
	public Dialog1(JFrame parent, DefaultSupport support)
	{
		super(parent,false);
		this.parent = parent;
		this.support = support;
		
		setUndecorated(true);
		setResizable(false);
	}
	
	public void showContent(JComponent content, int width)
	{
		setContentPane(content);
		pack();
		setSize(width,getHeight());
		setLocationRelativeTo(null);
		
		Toolkit.getDefaultToolkit().addAWTEventListener(this,AWTEvent.MOUSE_EVENT_MASK);
		parent.addWindowStateListener(this);
		setVisible(true);
	}
	
	

	public void eventDispatched(AWTEvent event)
	{if(event.getID()==501) hideContent();}
	
	
	public void windowStateChanged(WindowEvent e)
	{hideContent();}
	
	
	
	public void hideContent()
	{
		if(!isVisible()) return;
		dispose();
		dialogHidden();
	}
	
	
	public void dispose()
	{
		Toolkit.getDefaultToolkit().removeAWTEventListener(this);
		parent.removeWindowStateListener(this);
		super.dispose();
	}
	
	
	
	private void dialogHidden()
	{support.send(this,"dialogHidden()");}
}
