package gus05.entity.gus.graphic.list.rendering0;


import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Register;
import gus05.framework.resources.IconProvider;



public class ListRendering0 implements Entity, Register {


    public String getName()				{return "gus.graphic.list.rendering0";}
    public String getCreationDate()		{return "2007.02.04";}

    
    private Color color = Color.GREEN;
    
    private IconProvider iconProvider;
    
    private Icon icon(String key)
    {return iconProvider.getIcon(key);}
    

    public ListRendering0() throws Exception
    {iconProvider = (IconProvider) Outside.resource(this,"app.gui.icons");}



    public void register(String key, Object obj) throws Exception
    {
        if(key.equals("color")) {color = (Color)obj;return;}
        
        JList list = (JList)obj;
        list.setCellRenderer(new ListRenderer0(key,color));
    }


    
    
    
    private class ListRenderer0 extends JLabel implements ListCellRenderer
    {
        private Font plain_font;
        private Font bold_font;
        private Color c;
        
        public ListRenderer0(String iconID, Color c)
        {
            setOpaque(true);
            setIcon(icon(iconID));
            this.c = c;
            
            plain_font = getFont().deriveFont(Font.PLAIN);
            bold_font = getFont().deriveFont(Font.BOLD);
            
            setFont(plain_font);
            setBackground(Color.WHITE);
        }

        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
        {
            if(isSelected)
            {
                setFont(bold_font);
                setForeground(c);
            }
            else
            {
                setFont(plain_font);
                setForeground(Color.BLACK);
            }
            setText(value.toString());
            return this;
        }
    }
}

