
package gus05.entity.gus.graphic.panel.screen.image;

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.URL;



public class ScreenJPanel extends JPanel {

	public static String NORMAL_MODE = "normal";
	public static String ADJUSTED_MODE = "adjusted";
	public static String DISTORTED_MODE = "distorted";

	protected Image image;
	protected String mode;
	protected Color screenColor = Color.BLACK;



	public ScreenJPanel()
	{mode = ADJUSTED_MODE;}   

	public ScreenJPanel(String initialMode)
	{mode = initialMode;} 



	public void setMode(String mode)
	{this.mode = mode;}

	public String getMode()
	{return mode;}



	public void setScreenColor(Color color)
	{screenColor = color;}

	public Color getScreenColor()
	{return screenColor;}





	public Image getImage()
	{return image;}




	public void loadImage(byte[] data)
	{setImage(Toolkit.getDefaultToolkit().createImage(data));}

	public void loadImage(File file)
	{setImage(Toolkit.getDefaultToolkit().createImage(file.getAbsolutePath()));}

	public void loadImage2(File file)
	{setImage(Toolkit.getDefaultToolkit().getImage(file.getAbsolutePath()));}

	public void loadImage2(URL url)
	{setImage(Toolkit.getDefaultToolkit().getImage(url));}



	public void setImage(Image image)
	{this.image = image;}



	public void paintComponent(Graphics g)
	{
		Graphics2D g2 = (Graphics2D)g;
		g2.setColor(screenColor);
		g2.fillRect(0,0,getWidth(),getHeight());

		if(image==null)return;
		if(image.getHeight(this)<=0)return;


		if(mode.equals(DISTORTED_MODE))
			g2.drawImage(image,0,0,getWidth(),getHeight(),null);

		if(mode.equals(NORMAL_MODE))
		{g2.drawImage(image,0,0,image.getWidth(this),image.getHeight(this),this);}

		if(mode.equals(ADJUSTED_MODE))
		{
			double cx = (double)getWidth()/image.getWidth(this);
			double cy = (double)getHeight()/image.getHeight(this);

			if(cx>=cy)
			{
				int a = (int)((getWidth()-image.getWidth(this)*cy)/2);
				g2.drawImage(image,a,0,(int)Math.ceil(image.getWidth(this)*cy),getHeight(),this);
			}
			if(cx<cy)
			{
				int a = (int)((getHeight()-image.getHeight(this)*cx)/2);		
				g2.drawImage(image,0,a,getWidth(),(int)Math.ceil(image.getHeight(this)*cx),this);
			}
		}
	}

}