
package gus05.entity.gus.graphic.persistence.persistence1;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;

import javax.swing.AbstractButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JSlider;
import javax.swing.JSpinner;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.text.JTextComponent;



public class Persistence1 implements Entity, Register {

    public String getName()				{return "gus.graphic.persistence.persistence1";}
    public String getCreationDate()		{return "2006.07.08";}

    
    
    private Service pers;
    
    public Persistence1() throws Exception
    {pers = Outside.service(this,"app.pers");}

	
	
	
    public void register(String key, Object obj) throws Exception
    {
        if(obj instanceof AbstractButton)
        {register_AbtractButton(key,(AbstractButton)obj);return;}
        if(obj instanceof JComboBox)
        {register_JComboBox(key,(JComboBox)obj);return;}
        if(obj instanceof JList)
        {register_JList(key,(JList)obj);return;}
        if(obj instanceof JTabbedPane)
        {register_JTabbedPane(key,(JTabbedPane)obj);return;}
        if(obj instanceof JTextComponent)
        {register_JTextComponent(key,(JTextComponent)obj);return;}
        if(obj instanceof JLabel)
        {register_JLabel(key,(JLabel)obj);return;}
        if(obj instanceof JTable)
        {register_JTable(key,(JTable)obj);return;}
        if(obj instanceof JFileChooser)
        {register_JFileChooser(key,(JFileChooser)obj);return;}
        if(obj instanceof JSlider)
        {register_JSlider(key,(JSlider)obj);return;}
        if(obj instanceof JSpinner)
        {register_JSpinner(key,(JSpinner)obj);return;}
        
        throw new Exception("Invalid type: "+obj.getClass().getName());
    }
    
    
    
    
    private void register_AbtractButton(String key, AbstractButton button) throws Exception
    {new Persistence_AbstractButton(pers,key,button);}
    
    private void register_JComboBox(String key, JComboBox combo) throws Exception
    {new Persistence_JComboBox(pers,key,combo);}
    
    private void register_JList(String key, JList list) throws Exception
    {new Persistence_JList(pers,key,list);}
    
    private void register_JTabbedPane(String key, JTabbedPane tabbedPane) throws Exception
    {new Persistence_JTabbedPane(pers,key,tabbedPane);}
    
    private void register_JTextComponent(String key, JTextComponent comp) throws Exception
    {new Persistence_JTextComponent(pers,key,comp);}
    
    private void register_JLabel(String key, JLabel comp) throws Exception
    {new Persistence_JLabel(pers,key,comp);}
    
    private void register_JTable(String key, JTable table) throws Exception
    {new Persistence_JTable(pers,key,table);}
    
    private void register_JFileChooser(String key, JFileChooser fileChooser) throws Exception
    {new Persistence_JFileChooser(pers,key,fileChooser);}
    
    private void register_JSlider(String key, JSlider slider) throws Exception
    {new Persistence_JSlider(pers,key,slider);}
    
    private void register_JSpinner(String key, JSpinner spinner) throws Exception
    {new Persistence_JSpinner(pers,key,spinner);}
}
