/*
 * Framework gus04
 * 
 * Copyright (C) 2005 (Augustin Delale)
 * Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes
 * de la Licence Publique Gnrale GNU publie par la Free Software Foundation (version 2
 * ou bien toute autre version ultrieure choisie par vous).
 * 
 * Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE, 
 * ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation
 * dans un but spcifique. Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.
 * 
 * Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme ;
 * si ce n'est pas le cas, crivez  la Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, tats-Unis. 
 */
package gus05.entity.gus.graphic.persistence.persistence1;

import gus05.framework.core.Service;

import javax.swing.AbstractButton;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


class Persistence_AbstractButton implements ChangeListener {

    
    private AbstractButton button;
    private String key;
    private Service pers;
    
    
    
    public Persistence_AbstractButton(Service pers, String key, AbstractButton button) throws Exception
    {
        this.button = button;
        this.key = key;
        this.pers = pers;
        
        String value = (String)pers.retrieve(key);
        if(value!=null)
        {
            boolean b = Boolean.parseBoolean(value);
            button.setSelected(b);
        }
        button.addChangeListener(this);
    }


    
    public void stateChanged(ChangeEvent e)
    {update();}
    
    
    
    private void update()
    {
        try
        {
            pers.register(key,""+button.isSelected());
        }
        catch(Exception e){}
    }
    
}
