
package gus05.entity.gus.graphic.persistence.positions1;

import gus05.framework.core.Service;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;



class PersistenceHolder implements ComponentListener {

    
    private Component comp;
    private String key;
    private Service pers;
    
    
    
    public PersistenceHolder(Service pers, String key, Component comp) throws Exception
    {
        this.comp = comp;
        this.key = key;
        this.pers = pers;
        
        String value = (String)pers.retrieve(key);
        if(value!=null)
        {
            int[] p = findPosition(value);
            comp.setBounds(p[0],p[1],p[2],p[3]);
        }
        comp.addComponentListener(this);
    }
    


	public void componentHidden(ComponentEvent e) {}
	public void componentMoved(ComponentEvent e) {update();}
	public void componentResized(ComponentEvent e) {update();}
	public void componentShown(ComponentEvent e) {}
    
	
	
	
	
	private void update()
    {
        try
        {
        	Rectangle r = comp.getBounds();
        	String v = r.x+" "+r.y+" "+r.width+" "+r.height;
            pers.register(key,v);
        }
        catch(Exception e){}
    }
	
	
	private int[] findPosition(String value)
	{
		int[] p = new int[4];
		String[] n = value.split(" ");
		for(int i=0;i<4;i++)
			p[i] = Integer.parseInt(n[i]);
		return p;
	}
}
