
package gus05.entity.gus.graphic.tree.tooltip;

import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.ToolTipManager;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreePath;


class TooltipHandler extends MouseMotionAdapter {

    private JTree tree;

    public TooltipHandler(JTree tree)
    {
        super();
        this.tree = tree;
        tree.addMouseMotionListener(this);
        ToolTipManager.sharedInstance().registerComponent(tree);
    }
    
    
    public void mouseMoved(MouseEvent evt)
    {
        Point p = evt.getPoint();
        
        TreePath path = tree.getPathForLocation(p.x,p.y);
        int row = tree.getRowForLocation(p.x,p.y);
        if(path==null)return;
        
        Object target = path.getLastPathComponent();
        TreeCellRenderer renderer = tree.getCellRenderer();
        
        JLabel label = (JLabel) renderer.getTreeCellRendererComponent(tree,target,false,false,false,row,false); 
        
        if(target!=null)
            label.setToolTipText(target.toString());
        else label.setToolTipText(null);
    }
}
