package gus05.entity.gus.watching.online;


import java.io.IOException;
import java.io.PrintStream;
import java.net.URL;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Filter;
import gus05.framework.features.Retrieve;
import gus05.framework.tools.DefaultSupport;



public class WatchingOnline extends DefaultSupport implements Entity, Filter, Retrieve {


    public String getName()				{return "gus.watching.online";}
    public String getCreationDate()		{return "2007.07.30";}

    
    
    public static final String URLTEST = "http://www.google.com";
    public static final long PERIOD = 1000;
    
    
    private URL urlTest;
    private boolean isOnline = false;
    private Exception e;

    private PrintStream out;
    private Timer timer;
    private TimerTask task;
    

    
    public WatchingOnline() throws Exception
    {
        out = (PrintStream) Outside.resource(this,"out");
        urlTest = new URL(URLTEST);
        testConnection();
        
        task = new TimerTask(){public void run()
        {testConnection();}};
        
        timer = new Timer();
        timer.schedule(task,new Date(),PERIOD);
    }
    
    
    
    
    private void testConnection()
    {
        try
        {
            urlTest.openConnection().connect();
            this.e = null;
            if(isOnline) return;
            
            isOnline = true;
            out.println("Internet connection detected");
            online();
        }
        catch(IOException e)
        {
            this.e = e;
            if(!isOnline) return;
            
            isOnline = false;
            out.println("Internet connection lost");
            offline();
        }
    }



    public boolean filter(Object obj) throws Exception
    {return isOnline;}
    
    
    
    private void online()
    {send(this,"online()");}
    
    private void offline()
    {send(this,"offline()");}
    
    
    
    public Object retrieve(String key) throws Exception
    {
        if(key.equals("exception")) return e;
        if(key.equals("keys")) return new String[]{"exception"};
        throw new Exception("Unknown key: "+key);
    }


}

