package gus05.entity.gus.web.download.filedownloader.monitor.dialog1.auth1;


import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.URL;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;
import gus05.framework.features.Execute;
import gus05.framework.features.Support;



public class FileDownloaderDialog1Auth1 implements Entity, Register, Execute, Support, ActionListener {


    public String getName()				{return "gus.web.download.filedownloader.monitor.dialog1.auth1";}
    public String getCreationDate()		{return "2009.01.30";}

    
    public static final Border emptyBorder = BorderFactory.createEmptyBorder(10,10,10,10);
    public static final Border raisedBorder = BorderFactory.createBevelBorder(BevelBorder.RAISED);
    
    

    private Service downloader;
    private Service progress;
    
    private String message = "Downloading data, please wait.";
    private File file;
    private URL url;
    private String login;
    private String password;
    
    private JPanel panel;
    private JLabel labelMessage;
    private JComponent progressComp;
    
    private JFrame mainFrame;
    private JDialog dialog;
    

    public FileDownloaderDialog1Auth1() throws Exception
    {
    	downloader = Outside.service(this,"gus.web.download.filedownloader.auth1");
    	progress = Outside.service(this,"gus.graphic.progressbar.progress1");
        mainFrame = (JFrame) Outside.resource(this,"app.gui.frame");
    	
        downloader.addActionListener(this);
    	downloader.register("progress",progress);
    	
    	labelMessage = new JLabel(message);
    	labelMessage.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    	
    	progressComp = progress.gui();
    	progressComp.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    	
    	panel = new JPanel(new GridLayout(1,2));
    	panel.setBorder(BorderFactory.createCompoundBorder(raisedBorder,emptyBorder));
    	panel.add(labelMessage);
    	panel.add(progressComp);
    	
    	dialog = new JDialog(mainFrame,false);
    	dialog.setUndecorated(true);
    	dialog.setContentPane(panel);
    	dialog.pack();
    	dialog.setResizable(false);
    	
    	dialog.setLocationRelativeTo(null);
    }

    
    
    public void addActionListener(ActionListener listener) {downloader.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {downloader.removeActionListener(listener);}
	public List listeners() {return downloader.listeners();}
	
    

    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("message")) {message = (String)obj;return;}
    	if(key.equals("url")) {url = (URL)obj;return;}
    	if(key.equals("file")) {file = (File)obj;return;}
    	if(key.equals("login")){login = (String) obj;return;}
        if(key.equals("password")){password = (String) obj;return;}
        
        throw new Exception("Unknown key: "+key);
    }
    

    public void execute() throws Exception
    {
    	if(file==null) throw new Exception("file has not been initialized");
    	if(url==null) throw new Exception("url has not been initialized");
    	
    	downloader.register("file",file);
        downloader.register("url",url);
        downloader.register("login",login);
        downloader.register("password",password);
        labelMessage.setText(message);
        
        showDialog();
        new Thread(downloader).start();
    }



    public void actionPerformed(ActionEvent e)
    {
    	String command = e.getActionCommand();
    	
    	if(command.equals("downloadCompleted()"))hideDialog();
    	else if(command.equals("downloadFailed()"))hideDialog();
    }
    
    
    
    
    private void showDialog()
    {
    	dialog.setVisible(true);
    }
    
    private void hideDialog()
    {
    	dialog.setVisible(false);
    }
	


}

