package gus05.entity.gus.web.download.urltoproperties.auth1;


import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URL;
import java.net.URLConnection;
import java.util.Properties;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Register;
import gus05.framework.features.Transform;



public class UrlToPropertiesAuth1 implements Entity, Transform, Register {


    public String getName()				{return "gus.web.download.urltoproperties.auth1";}
    public String getCreationDate()		{return "2009.01.22";}

    
    
    private Service setAuth1;
    
    private String login;
    private String password;
    
    public UrlToPropertiesAuth1() throws Exception
    {
    	setAuth1 = Outside.service(this,"gus.web.authorization.setauth1");
    }
    
    
    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("login")){login = (String) obj;return;}
        if(key.equals("password")){password = (String) obj;return;}
        throw new Exception("Unknown key: "+key);
	}
    
    
    private void setAuthorization(URLConnection con) throws Exception
    {setAuth1.give(new Object[]{con,login,password});}
    
    
    



    public Object transform(Object obj) throws Exception
    {
        URL url = toURL(obj);
        return properties(url);
    }
    
    
    
    
    
    private URL toURL(Object obj) throws Exception
    {
        if(obj instanceof URL) return (URL)obj;
        if(obj instanceof URI) return ((URI)obj).toURL();
        if(obj instanceof String) return new URL((String)obj);
        throw new Exception("Invalid data type: "+obj.getClass().getName());
    }

    
    

    
    
    
    private Properties properties(URL url) throws Exception
    {
    	URLConnection con = url.openConnection();
    	if(login!=null && password!=null) setAuthorization(con);
    	con.connect();
        
        InputStream is = con.getInputStream();
        Properties prop = new Properties();
        prop.load(is);
        is.close();
        
        if(con instanceof HttpURLConnection)
            ((HttpURLConnection)con).disconnect();
        return prop;
    }
	


}

