package gus05.entity.gus.web.url.textfield1;


import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.framework.resources.IconProvider;
import gus05.framework.tools.DefaultSupport;

import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;



public class UrlTextField1 extends DefaultSupport implements Entity, Give, Provide, Graphic {


    public String getName()				{return "gus.web.url.textfield1";}
    public String getCreationDate()		{return "2006.08.19";}



    private Service dnd;
    private IconProvider iconProvider;
    
    private URL url;
    private Icon urlIcon;
    
    private JPanel panel;
    private JLabel label;
    private JTextField textField;

    
    
    public UrlTextField1() throws Exception
    {
        dnd = Outside.service(this,"gus.graphic.dnd");
        iconProvider = (IconProvider)Outside.resource(this,"app.gui.icons");
        urlIcon = iconProvider.getIcon("OBJECT_Url");
        
        label = new JLabel();
        label.setIcon(urlIcon);
        
        textField = new JTextField();
        
        textField.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e)
            {fromTextField();}});
        
        textField.getDocument().addDocumentListener(new DocumentListener(){
            public void insertUpdate(DocumentEvent e) {textChanged();}
            public void removeUpdate(DocumentEvent e) {textChanged();}
            public void changedUpdate(DocumentEvent e) {}
        });
        
        dnd.register("give",this);
        dnd.register("provide",this);
        dnd.register("comp",label);
        
        panel = new JPanel(new BorderLayout());
        panel.add(label,BorderLayout.WEST);
        panel.add(textField,BorderLayout.CENTER);
    }
    
    
    
    private void fromTextField()
    {
        try
        {
            String s = textField.getText();
            give(new URL(normalize(s)));
        }
        catch(MalformedURLException e){}
        catch(Exception e)
        {Outside.err(this,"fromTextField()",e);}
    }


    
    public JComponent gui()
    {return panel;}

    
    public Object provide() throws Exception
    {return url;}
    
    
    public void give(Object obj) throws Exception
    {
        url = toURL(obj);
        handleURL();
    }
    
    
    
    private URL toURL(Object obj) throws MalformedURLException
    {
        if(obj instanceof URL) return (URL)obj;
        if(obj instanceof File) return ((File)obj).toURI().toURL();
        
        return new URL(normalize(obj.toString()));
    }


    
    
    private void handleURL()
    {
        label.setToolTipText(url.toString());
        textField.setText(url.toString());
        send(this,"handleURL()");
    }
    
    
    
    private void textChanged()
    {
        if(url==null) textField.setForeground(Color.RED);
        else 
        {
            if(url.toString().equals(normalize(textField.getText())))
                textField.setForeground(Color.BLACK);
            else textField.setForeground(Color.RED);
        }
    }
    


    private String normalize(String s)
    {
        if(!s.contains(":")) s = "http://"+s;
        return s;
    }
}

