package gus05.entity.gus.website.restrict.getfile1;


import java.awt.event.ActionListener;
import java.io.File;
import java.io.PrintStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.core.Service;
import gus05.framework.features.Give;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;



public class GetFile1 implements Entity, Give, Register, Retrieve, Support {


    public String getName()				{return "gus.website.restrict.getfile1";}
    public String getCreationDate()		{return "2009.01.30";}


    public static final String DOWNLOADPATH = "download";
    
    
    private Service downloadDialog;
    
    private String userName;
    private String password;
    private String place;
    private String fileName;
    private String timeStamp;
    
    private PrintStream out;
    private String url_root;
    
    private File file;
    
    
    

    public GetFile1() throws Exception
    {
    	downloadDialog = Outside.service(this,"gus.web.download.filedownloader.monitor.dialog1.auth1");
    	out = (PrintStream) Outside.resource(this,"out");
    	url_root = (String) Outside.resource(this,"urlroot_release");
    	if(!url_root.endsWith("/")) url_root = url_root+"/";
    }



    public void give(Object obj) throws Exception
    {
    	if(userName==null) throw new Exception("userName has not been initialized yet");
    	if(password==null) throw new Exception("password has not been initialized yet");
    	if(place==null) throw new Exception("place has not been initialized yet");
    	if(fileName==null) throw new Exception("fileName has not been initialized yet");
    	if(timeStamp==null) throw new Exception("timeStamp has not been initialized yet");
    	
    	file  = (File) obj;
    	perform();
    }



    public void register(String key, Object obj) throws Exception
    {
    	if(key.equals("userName")) {userName = (String) obj;return;}
    	if(key.equals("password")) {password = (String) obj;return;}
        if(key.equals("place")) {place = (String) obj;return;}
        if(key.equals("fileName")) {fileName = (String) obj;return;}
        if(key.equals("timeStamp")) {timeStamp = (String) obj;return;}
        if(key.equals("out")) {out = (PrintStream) obj;return;}
        
        throw new Exception("Unknown key: "+key);
    }

    
    
    
    
    public Object retrieve(String key) throws Exception
    {
    	if(key.equals("releaseURL")) return releaseURL();
		if(key.equals("keys")) return new String[]{"releasURL"};
    	
    	throw new Exception("Unknown key: "+key);
	}
    
    
    
    
    
    private URL releaseURL() throws MalformedURLException
    {return new URL(url_root+place+"/"+DOWNLOADPATH+"/"+timeStamp+"/"+fileName);}

    
    
    private void perform() throws Exception
    {
    	try
    	{
    		URL url = releaseURL();
        	
            out.println("downloading file: "+file.getName());
            
            downloadDialog.register("file",file);
            downloadDialog.register("url",url);
            downloadDialog.register("login",userName);
            downloadDialog.register("password",password);
            downloadDialog.execute();
    	}
    	catch(Exception e)
    	{
    		if(file!=null && file.exists())
    			file.delete();
    		throw e;
    	}
    }
    
    
    
    
    public void addActionListener(ActionListener listener) {downloadDialog.addActionListener(listener);}
	public void removeActionListener(ActionListener listener) {downloadDialog.removeActionListener(listener);}
	public List listeners() {return downloadDialog.listeners();}
}

