package gus05.entity.gus.website.restrict.getreleaseurl;


import java.io.FileNotFoundException;
import java.net.URL;

import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Retrieve;



public class GetReleaseUrl implements Entity, Retrieve {


    public String getName()				{return "gus.website.restrict.getreleaseurl";}
    public String getCreationDate()		{return "2009.02.11";}


    public static final String FILE_CREATEDHTML = "created.html";
    public static final String FILE_RELEASEPROP = "release.properties";
    
    private String url_root;
    

    public GetReleaseUrl() throws Exception
    {
    	url_root = (String) Outside.resource(this,"urlroot_release");
    	if(!url_root.endsWith("/")) url_root = url_root+"/";
    }



    public Object retrieve(String key) throws Exception
    {
    	String place = key;
    	URL createdURL = new URL(url_root+place+"/"+FILE_CREATEDHTML);
    	URL releaseURL = new URL(url_root+place+"/"+FILE_RELEASEPROP);
    	
    	if(!found(createdURL)) throw new Exception("Restricted area not found: "+place);
        return releaseURL;
    }


    
    
    
    private boolean found(URL url)
    {
    	try{url.openStream().close();}
    	catch(Exception e)
    	{if(e instanceof FileNotFoundException)return false;}
    	return true;
    }
}

