/*
 * This Java source code is part of the gus05 framework
 * Please visit the gus05 framework Project website for more details
 * http://www.gus05.com
 * 
 * Copyright (c)2007 Augustin Delale
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * to deal in the Software without restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute,sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 */
package gus05.framework.tools;

import gus05.framework.features.Support;

import java.util.*;
import java.awt.event.*;


public class DefaultSupport implements Support, Send {

    
    private Vector listeners;
    
    public DefaultSupport()
	{listeners = new Vector();}
    
    
	
    
    //*****************************************
	
	public final static int eventID = 1000;
	
	public synchronized void addActionListener(ActionListener listener)
	{listeners.add(listener);}

	public synchronized void removeActionListener(ActionListener listener)
	{listeners.remove(listener);}
	
	public synchronized List listeners()
	{return listeners;}
	
	
	
	
	private synchronized void fireActionEvent(Object source, String id)
	{ 
	    if(source==null)source=this;
		ActionEvent evt = new ActionEvent(source,eventID,id);
			
		for(int i=0;i<listeners.size();i++)
		{
		    ActionListener listener = (ActionListener)listeners.get(i);
			listener.actionPerformed(evt);
		}
	}
	
	
	
	
	//*****************************************
	
	private boolean activated = true;
	
	public void setActivated(boolean value)
	{activated = value;}
	
	public boolean isActivated()
	{return activated;}
	

    public void send(Object source, String id)
    {
        if(activated)
        fireActionEvent(source,id);
    }

	
}
