package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_file;

import java.io.File;
import java.util.Properties;


public class Loader_debug extends Loader {

    
    public Loader_debug()
    {super("debug");}  
    
    
    protected void insideLoad(){}
    
    
    protected void outsideLoad()
    {
        try
        {
            File f = new File(System1.rootDir,System1.FILENAME_DEBUG);
            f = outsideFile(f,"debug file");
            if(f==null) return;
            
            Properties p = Tools_file.prop(f);
            
            if(System1.initOutside)
                initProperties(p,f);
            
            registerProperties(p);
            
            debug("outsideLoad()","load "+p.size()+" debugs from: "+f.getAbsolutePath());
        }
        catch(Exception e)
        {System1.handleError(this,"outsideLoad()",e);}
    }
    
    
    
    private void registerProperties(Properties p)
    {
        System1.properties.putAll(p);
        increase(p.size());
    }
    
    
    
    
    private void initProperties(Properties p, File f)
    {
        try
        {
            check(p,System1.PROPKEY_DEBUGPROP);
            check(p,System1.PROPKEY_DEBUGFILES);
            check(p,System1.PROPKEY_DEBUGURLS);
            check(p,System1.PROPKEY_DEBUGMAPPING);
            check(p,System1.PROPKEY_DEBUGSTART);
            check(p,System1.PROPKEY_DEBUGINTERNALS);
            check(p,System1.PROPKEY_DEBUGPROVIDERS);
            
            Tools_file.saveProp(f,p);
        }
        catch(Exception e)
        {System1.handleError(this,"initProperties(Properties, File)",e);}
    }
    
    
    private void check(Properties p, String key)
    {if(!p.containsKey(key)) p.setProperty(key,"true");}
}
