package gus05.manager.gus.endorf.layer3.system1;

import gus05.manager.gus.endorf.layer3.loading.Loader;

import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class UrlManager {

    
    public static final Pattern tag_pattern = Pattern.compile("<([^>]+)>");
    
    
    
    public boolean checkURL(String key)
    {
        if(!System1.hasProperty(key)) return false;
        String path = System1.getProperty(key);
        
        if(path.startsWith("inside:"))
            return checkInsideURL(key,path);
        else return checkOutsideURL(key,path);
    }
    
    
    
    
    public boolean checkOutsideURL(String key, String path)
    {
        try
        {
            URL url = resolveURL(path);
            System1.putURL(key,url);
            return true;
        }
        catch(Exception e)
        {System1.handleError(this,"checkOutsideURL(String)",e);}
        return false;
    }
    
    
    
    
    
    public boolean checkInsideURL(String key, String path)
    {
        try
        {
            path = path.substring("inside:".length());
            URL url = Loader.insideURL(path);
            System1.putURL(key,url);
            return true;
        }
        catch(Exception e)
        {System1.handleError(this,"checkInsideURL(String)",e);}
        return false;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    private URL resolveURL(String path) throws Exception
    {
        int c = 0;
        while(path.startsWith("<"))
        {
            c++;
            Matcher m = tag_pattern.matcher(path);
            if(!m.find()) throw new Exception("wrong syntax for fileID: "+path);
            String tag = m.group(1);
            
            if(System1.hasURL(tag))
            {
                URL url = System1.url(tag);
                path = path.replace(m.group(), url.toString());
            }
            else if(System1.hasProperty(tag))
            {
                String path0 = System1.getProperty(tag);
                path = path.replace(m.group(),path0);
            }
            else throw new Exception("urlID "+path+" can not be resolved");
            
            path = path.replace("//","/");
            
            if(c>100) System1.FATAL_ERROR(this,"resolveURL(String)","infinite loop detected\nstopping at path "+path);
        }
        return new URL(path);
    }
    
    
    
}
