
package gus05.manager.gus.endorf.layer3.tools;



import gus05.manager.gus.endorf.layer4.system2.System2;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Properties;
import java.util.Set;



public class Tools_url {

    

    
    public static String readText(URL url) throws Exception
    {
        InputStreamReader isr = new InputStreamReader(url.openStream());
        
        int c = 0;
        StringBuilder b = new StringBuilder();
        while((c=isr.read())!=-1) b.append((char)c);
        return Tools_encoding.decode(b.toString()); 
    }
    
    
    
    /*
     * revoir la mthode readLines pour avoir un chargement consistent
     */
    public static String[] readLines(URL url) throws Exception
    {
        String text = readText(url);
        if(text.equals("")) return new String[0];
        //text = text.replace("\r","");
        return text.split("[\r\n]+");
    }
    
    
    public static List loadList(URL url) throws Exception
    {return new ArrayList(Arrays.asList(readLines(url)));}
    
    
    public static Set loadSet(URL url) throws Exception
    {return new HashSet(Arrays.asList(readLines(url)));}
    
    
    
    public static Properties loadProperties(URL url) throws Exception
    {
        Properties prop = new Properties();
        prop.load(url.openStream());
        return prop;
    }
    
    
    
    
    public static void copyFileFromURL(URL in, File out) throws Exception
    {
        out.getParentFile().mkdirs();
        FileOutputStream fos = new FileOutputStream(out);
        
        InputStream is = in.openStream();
        int b;
        while((b = is.read())!=-1) fos.write(b);
        is.close();
        fos.close();
        
        System2.printDebug(Tools_url.class,"copyFileFromURL(URL,File)","copy url: "+in+" into file: "+out);
    }

    
}
