/*
 * Created on 12 juin 2006
 *
 */
package gus05.manager.gus.endorf.layer4.system2;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Map;

import javax.swing.Action;
import javax.swing.Icon;

import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Support;
import gus05.manager.gus.endorf.layer2.datasupport.SupportMap;


public class ActionManager implements Register, Retrieve, ActionListener {

    
    
    private Map actionsMap;
    private Map infosMap;
    
    public Map getActionsMap()
    {return actionsMap;}
    
    public Map getActionInfosMap()
    {if(infosMap==null) initInfosMap();return infosMap;}
    
    
    public void initInfosMap()
    {
        infosMap = System2.getDataMap0(System2.LOCATION_ENTITYACTIONMAP);
        ((Support)infosMap).addActionListener(this);
    }
    
    
    
    
    
    
    public ActionManager()
    {
        actionsMap = new SupportMap("actionsMap");
    }
    
    
    
    public void init()
    {
        System2.registerToLing(this);
    }
    
    
    
    
    
    
    public void actionPerformed(ActionEvent e)
    {updateAllActions();}
    
    
    
    private void updateAllActions()
    {
        Iterator it = actionsMap.keySet().iterator();
        while(it.hasNext())
        {
            String actionID = (String)it.next();
            Action action = (Action) actionsMap.get(actionID);
            updateAction(actionID,action);
        }
    }
    

    
    
    public void register(String key, Object obj) throws Exception
    {handleAction(key,(Action)obj);}
    
    
    public Object retrieve(String key) throws Exception
    {return actionsMap.get(key);}
    
    
    
    private void handleAction(String actionID, Action action)
    {
        if(!infosMap.containsKey(actionID))
            infosMap.put(actionID,"");
        
        int i=0;
        while(actionsMap.containsKey(actionID+":"+i))i++;
        actionID = actionID+":"+i;  
        
        actionsMap.put(actionID,action);
        updateAction(actionID,action);
    }
    
    
    
    
    private void updateAction(String actionID, Action action)
    {
        try
        {
            String info = getInfo(actionID);
            if(info==null || info.equals(""))
            {
                String callID = getCallID(actionID);
                action.putValue(Action.NAME,getName0(callID));
                action.putValue(Action.SHORT_DESCRIPTION,getDescription0(callID));
                action.putValue(Action.SMALL_ICON,getIcon(callID));
                return;
            }
            String[] n = info.split("#",2);
            
            if(n.length==2)
            {
                String iconID = n[0];
                String stringID = n[1];
                action.putValue(Action.NAME,getName1(stringID));
                action.putValue(Action.SHORT_DESCRIPTION,getDescription1(stringID));
                action.putValue(Action.SMALL_ICON,getIcon(iconID));
            }
            if(n.length==1)
            {
                action.putValue(Action.NAME,getName1(info));
                action.putValue(Action.SHORT_DESCRIPTION,getDescription1(info));
                action.putValue(Action.SMALL_ICON,getIcon(System2.ICONKEY_DEFAULT));
            }
        }
        catch(Exception e)
        {System2.handleError(this,"updateAction(String,Action)",e);}
    }
    
    
    
    private String getCallID(String actionID)
    {return actionID.split(":")[0].split("@")[1];}
    
    
    private String getInfo(String actionID)
    {return (String) infosMap.get(actionID.split(":")[0]);}

    
    
    
    
    
   
    private Icon getIcon(String key)
    {
        Icon icon = (Icon) System2.iconMap.get(key);
        if(icon==null)return (Icon) System2.iconMap.get(System2.ICONKEY_DEFAULT);
        return icon;
    }
    
    
    
    
    private String getName0(String key)
    {
        String s = System2.ling(System2.LINGTAG_ACTIONNAME+key);
        if(!s.equals(System2.LINGTAG_ACTIONNAME+key)) return s;
        
        s = System2.ling(key);
        if(!s.equals(key)) return s;
        
        return "";
    }
    
    
    
    
    private String getDescription0(String key)
    {
        String s = System2.ling(System2.LINGTAG_ACTIONDESC+key);
        if(!s.equals(System2.LINGTAG_ACTIONDESC+key)) return s;
        return getName0(key);
    }
    
    
    
    
    private String getName1(String key)
    {
        String s = System2.ling(System2.LINGTAG_ACTIONNAME+key);
        if(!s.equals(System2.LINGTAG_ACTIONNAME+key)) return s;
        
        s = System2.ling(key);
        if(!s.equals(key)) return s;
        
        return key;
    }
    
    
    
    
    private String getDescription1(String key)
    {
        String s = System2.ling(System2.LINGTAG_ACTIONDESC+key);
        if(!s.equals(System2.LINGTAG_ACTIONDESC+key)) return s;
        return getName1(key);
    }

    
}
